function Val = PlotGraph(data, R,dimLength, dims)
%%
% this function generates 2 plots 
% FOR THE FIRST GRAPH %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% dimLegth = data on X-Aixs
% R = Residual vaariances
% FOR THE SECOND GRAPH %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%data{i} = data{i}.coords is a cell array, with coordinates for d-dimensional embeddings
%         in data{i}.coords{d}.  data{i}.index (only for i = 1)contains the indices of the points embedded.
%    data{i}.index is Index of number of data
% dims is the dimensionality of the images data as entered by the user or
% the calculated by the function GetDimension
%%
   if nargin < 3
       dimLength = [1:10];
   end
   if nargin < 4
       dims = 2;
   end
   numData = size(data);
   numData = numData(1);
     figure;
     hold on
     plot(dimLength, R, 'bo'); 
     plot(dimLength, R, 'b-'); 
     hold off
     ylabel('Residual variance'); 
     xlabel('Isomap dimensionality'); 

     %%%%% Plot two-dimensional configuration %%%%%
     twod = dims;
     if ~isempty(twod)
         fig = figure;
         axes1 = axes('Visible', 'on', 'Parent', fig);
         hold on;
         plot(data{1}.coords{twod}(1,:), data{1}.coords{twod}(2,:), 'bo','Parent', axes1);
         legend(['--' num2str(data{1}.coords{11}(1,1))]);
         ImageX = (max(data{1}.coords{twod}(1,:)) - min(data{1}.coords{twod}(1,:)))/12;
         ImageY = (max(data{1}.coords{twod}(2,:)) - min(data{1}.coords{twod}(2,:)))/12;
         if numData > 1
             if isempty(data{2})==0
                 plot(data{2}.coords{twod}(1,:), data{2}.coords{twod}(2,:), 'kx','Parent', axes1);
                 legend(['--' num2str(data{1}.coords{11}(1,1))],['--' num2str(data{2}.coords{11}(1,1))]);
                 
           
                 %calculating the expansion of data in order to get approriate
                 %scaling of image clippings
                 % In X direction
                 ImageX = (max(max(data{1}.coords{twod}(1,:)),max(data{2}.coords{twod}(1,:))) - min(min(data{1}.coords{twod}(1,:)),min(data{2}.coords{twod}(1,:))))/12;
                 % In Y direction
                 ImageY = (max(max(data{1}.coords{twod}(2,:)),max(data{2}.coords{twod}(2,:))) - min(min(data{1}.coords{twod}(2,:)),min(data{2}.coords{twod}(2,:))))/12;
             end
         end
         if numData > 2 
             plot(data{3}.coords{twod}(1,:), data{3}.coords{twod}(2,:), 'ro','Parent', axes1);
             %legend(['--' num2str(data{1}.coords{11}(1,1))]);
             val1 = size(data{3}.coords{twod});
             val1 = val1(1,2);
             for i = 1:val1
                 for k=1:28
                     for j = 1:28
                        data1(k,j) = data{3}.coords{11}((k-1)*28 + j,i);
                     end
                 end
                 %size(data1)
                 Xpoint = data{3}.coords{twod}(1,i);
                 Ypoint = data{3}.coords{twod}(2,i);
                 colormap('gray');
                 
                image([Xpoint-(ImageX)/5, Xpoint-(ImageX)*6/5],[Ypoint-(ImageY)/5, Ypoint-(ImageY)*6/5],fliplr(data1), 'Parent', axes1);
             end
             
         end
         if numData > 3 
             plot(data{4}.coords{twod}(1,:), data{4}.coords{twod}(2,:), 'gx','Parent', axes1);
             %legend(['--' num2str(data{2}.coords{11}(1,1))]);
             val1 = size(data{4}.coords{twod});
             val1 = val1(1,2);
             for i = 1:val1
                     for k = 1:28
                         for j = 1:28
                             data1(k,j) = data{4}.coords{11}((k-1)*28 + j,i);
                         end
                     end
                     %size(data1)
                     Xpoint = data{4}.coords{twod}(1,i);
                     Ypoint = data{4}.coords{twod}(2,i);
                     colormap('gray');
                     image([Xpoint-(ImageX)/5, Xpoint-(ImageX)*6/5],[Ypoint-(ImageY)/5, Ypoint-(ImageY)*6/5],fliplr(data1), 'Parent', axes1);
             end 
         end
         title([num2str(dims),'th Dimensional Embedding']);
         hold off;
     end
     val = 1;
end
